;===========================================================================================
; AnimPub.asm  GoAsm assembler
; Animation rglable bandeau dfilant
; Programm par AsmGges France
;===========================================================================================
; compile.bat:
; ..\..\bin\GoRC /r, res\animpub.rc
; ..\..\bin\GoAsm animpub.asm
; ..\..\bin\GoLink animpub.obj res\animpub.res user32.dll kernel32.dll gdi32.dll winmm.dll
;===========================================================================================

; Inclusion des macros/quates/structures ncessaires au programme
; ----------------------------------------------------------------
  #include "..\..\inc\Windows.inc"
  #include "..\..\inc\all_api.inc"

  ID_FRANCE = 17

  ID_RUN    = 100
  ID_STOP   = 101
  ID_INC    = 102
  ID_DEC    = 103
  ID_GBOX   = 104

  DIB_RGB_COLORS = 0h

;===========================================================================================
; Dbut du code programme
; -----------------------
.code

 start:
    ; Obtenir le handle du programme
    ; ------------------------------
    invoke GetModuleHandle,0
    mov [wc.hInstance],eax

    ; Chargement d'une icne spcifique
    ; ---------------------------------
    invoke LoadIcon,[wc.hInstance],ID_FRANCE
    mov [wc.hIcon],eax

    ; Chargement d'un curseur systme
    ; -------------------------------
    invoke LoadCursor,0,IDC_ARROW
    mov [wc.hCursor],eax

    ; Obtenir la largeur en pixels de l'cran
    ; ---------------------------------------
    invoke GetSystemMetrics,SM_CXSCREEN
    sub eax,[WinW]
    shr eax,1
    mov [WinX],eax

    ; Valider la structure WNDCLASS
    ; -----------------------------
    invoke RegisterClass,addr wc

    ; Cration de la fenetre de l'application
    ; ---------------------------------------
    invoke CreateWindowEx,0,addr ClassName,addr Titre,WS_CAPTION+WS_POPUP+WS_SYSMENU \
                         +WS_MINIMIZEBOX,[WinX],[WinY],[WinW],[WinH],0,0,[wc.hInstance],0
    mov [hWnd],eax

    ; Affiche et rafraichit la fenetre
    ; --------------------------------
    invoke ShowWindow,[hWnd],SW_SHOWDEFAULT
    invoke UpdateWindow,[hWnd]

 ; Boucle des messages et animation
 ; --------------------------------
 MessageLoop:
    invoke PeekMessage,addr msg,0,0,0,PM_NOREMOVE
    or eax,eax
    je >
        invoke GetMessage,addr msg,0,0,0
        or eax,eax
        jz >ExitProgram
        invoke TranslateMessage,addr msg
        invoke DispatchMessage,addr msg
        jmp <MessageLoop
    :
    cmp D[BtRun],0
    je  >.timer

        cmp D[BtRun],166
        jae >
            ; Copie le bitmap pixel par pixel
            ; -------------------------------
            invoke BitBlt,[hAnimDC],14,24,166,68,[hMemDC],[Anim],0,SRCCOPY
            inc D[Anim]
            inc D[BtRun]
            jmp >.timer
        :
            mov D[BtRun],1
            mov D[Anim],0

    .timer:
    ; Timer pour animation
    ; --------------------
    invoke FpsLimiter,[FpsMax]

    jmp <MessageLoop

 ExitProgram:
    ; Fermeture de l'application
    ; --------------------------
    invoke ExitProcess,[msg.wParam]

;===========================================================================================
; Procdure principale Windows
;-------------------------------------------------------------------------------------------
WindowProc frame @hWnd, @uMsg, @wParam, @lParam
    uses ebx,esi,edi

    cmp D[@uMsg],WM_CLOSE
    jne >.wmcommand
        ; Boite  message fin d'application
        ; ---------------------------------
        invoke MessageBox,[@hWnd],addr MsgEnd,addr ClassName,MB_OK+MB_ICONINFORMATION

        ; Dsactiver timer
        ; ----------------
        invoke timeEndPeriod,1

        ; Supprimer le contexte de dispositif hDC de la fenetre principale
        ; ----------------------------------------------------------------
        invoke ReleaseDC,[hWnd],[hAnimDC]

        ; Supprimer l'objet bitmap
        ; ------------------------
        invoke DeleteObject,[hBitmap]

        ; Supprimer la mmoire alloue
        ; ----------------------------
        invoke DeleteDC,[hMemDC]

        ; Demande fin d'application
        ; -------------------------
        invoke PostQuitMessage,0
        jmp >>.exit

    .wmcommand:
    cmp D[@uMsg],WM_COMMAND
    jne >>.wmcreate
        cmp D[@lParam],0
        je >>.exit
            ; Click souris pour identification du bouton actionn
            ; ---------------------------------------------------
            mov eax,[@wParam]
            shr eax,16
            cmp ax,BN_CLICKED
            jne >>.exit
                ; Attente du bouton Run cliqu pour animation
                ; -------------------------------------------
                cmp W[@wParam],ID_RUN
                jne >
                    cmp D[Anim],0
                    jne >>.exit
                        mov D[BtRun],1
                        jmp >>.exit
                :
                cmp W[@wParam],ID_STOP
                jne >
                    mov D[BtRun],0
                    mov D[Anim],0

                    ; Repositionne au dpart le bitmap dans la fenetre
                    ; ------------------------------------------------
                    invoke BitBlt,[hAnimDC],14,24,166,68,[hMemDC],0,0,SRCCOPY
                    jmp >>.exit
                :
                cmp W[@wParam],ID_INC
                jne >
                    add D[FpsMax],10
                    jmp >>.exit
                :
                cmp W[@wParam],ID_DEC
                jne >>.exit
                    cmp D[FpsMax],20
                    jae >
                        mov D[FpsMax],15
                        jmp >>.exit
                    :
                        sub D[FpsMax],10
                        jmp >>.exit

    .wmcreate
    cmp D[@uMsg],WM_CREATE
    jne >>.wmpaint
        ; Cration de la fonte pour texte
        ; -------------------------------
        invoke CreateFont,8,0,0,0,400,0,0,0,ANSI_CHARSET,OUT_DEFAULT_PRECIS,\
                          CLIP_DEFAULT_PRECIS,DEFAULT_QUALITY,DEFAULT_PITCH+FF_SWISS,\
                                                                         addr FontMS
        mov [hFontMS],eax

        ; Construit tous les controles
        ; ----------------------------
        invoke CreateControls,[@hWnd]

        ; Initialisation timer
        ; --------------------
        invoke timeBeginPeriod,1
        mov D[FpsMax],75

        ; Obtenir le contexte de dispositif hDC de la fenetre principale
        ; --------------------------------------------------------------
        invoke GetDC,[@hWnd]
        mov [hAnimDC],eax

        ; Cration d'un dispositif bitmap indpendant
        ; -------------------------------------------
        mov ebx,addr ptBitmap                           ;addr BITMAPINFOHEADER
        invoke CreateDIBSection,0,ebx,DIB_RGB_COLORS,addr ppvBits,0,0
        mov [hBitmap],eax

        ; Copie le bitmap en mmoire
        ; --------------------------
        mov eax,addr ptBitmap+40                        ;addr src BitmapImage
        invoke MemCopy,eax,[ppvBits],[ebx+20]           ;BITMAPINFOHEADER.biSizeImage

        ; Cration d'un contexte de dispositif mmoire compatible
        ; -------------------------------------------------------
        invoke CreateCompatibleDC,[hAnimDC]
        mov [hMemDC],eax

        ; Choisit un objet suivant le contexte de dispositif hmdc
        ; -------------------------------------------------------
        invoke SelectObject,[hMemDC],[hBitmap]
        jne >.exit

    .wmpaint:
    cmp D[@uMsg],WM_PAINT
    jne >.defwindowproc:
        ; Dbut criture/dessin
        ; ---------------------
        invoke BeginPaint,[@hWnd],addr ps

        ; Copie normale
        ; -------------
        invoke BitBlt,[hAnimDC],14,24,166,68,[hMemDC],0,0,SRCCOPY

        ; Fin criture/dessin
        ; -------------------
        invoke EndPaint,[@hWnd],addr ps
        jmp >.exit

    .defwindowproc:
        ; Traitement par dfaut des autres messages Windows
        ; -------------------------------------------------
        invoke DefWindowProc,[@hWnd],[@uMsg],[@wParam],[@lParam]
        ret

    .exit:

    mov eax,0
    ret
endf

;===========================================================================================
CreateControls frame @hWnd

    ; Cration de la sous-fentre pour l'encadrement
    ; ----------------------------------------------
    invoke Dlg,addr Button,addr ButtonGBox,[@hWnd],4,2,186,20,ID_GBOX,BS_GROUPBOX,0  

    ; Cration de la sous-fentre pour le bouton +
    ; --------------------------------------------
    invoke Dlg,addr Button,addr ButtonInc,[@hWnd],14,98,62,22,ID_INC,0,0

    ; Cration de la sous-fentre pour le bouton -
    ; --------------------------------------------
    invoke Dlg,addr Button,addr ButtonDec,[@hWnd],118,98,62,22,ID_DEC,0,0

    ; Cration de la sous-fentre pour le bouton Run
    ; ----------------------------------------------
    invoke Dlg,addr Button,addr ButtonRun,[@hWnd],54,128,92,22,ID_RUN,0,0

    ; Cration de la sous-fentre pour le bouton Stop
    ; -----------------------------------------------
    invoke Dlg,addr Button,addr ButtonStop,[@hWnd],64,128+32,72,22,ID_STOP,0,0

    ret
endf

;===========================================================================================
; Cration d'une fentre-enfant control class
;-------------------------------------------------------------------------------------------
; @Class    = adresse du nom de control class
; @AdrText  = adresse du control text
; @hParent  = handle de la fentre parent
; @X        = x-coordonne fentre-enfant
; @Y        = y-coordonne fentre-enfant
; @Xw       = largeur en pixels fentre-enfant
; @Yh       = hauteur en pixels fentre-enfant
; @Id       = identificateur du controle forme ID_XXX
; @Style    = complment window style de WS_CHILD+WS_VISIBLE
; @ExStyle  = window style tendu
;-------------------------------------------------------------------------------------------
; => eax = handle de la fentre-enfant
;-------------------------------------------------------------------------------------------
Dlg frame @Class, @AdrText, @hParent, @X, @Y, @Xw, @Yh, @Id, @Style, @ExStyle

    mov eax,WS_CHILD+WS_VISIBLE
    add eax,[@Style]
    invoke CreateWindowEx,[@ExStyle],[@Class],[@AdrText],eax,[@X],[@Y],[@Xw],[@Yh],\
                          [@hParent],[@Id],[wc.hInstance],NULL
    mov ebx,eax

    ; Valider la fonte standard MS Sans Serif pour le control
    ; -------------------------------------------------------
    invoke SendMessage,ebx,WM_SETFONT,[hFontMS],NULL
    mov eax,ebx

    ret
endf

;===========================================================================================
; @AddrSrc  = adresse source de la zone mmoire  copier
; @AddrDest = adresse de destination de la copie
; @Size     = nombre d'octets  copier
;-------------------------------------------------------------------------------------------
MemCopy frame @AddrSrc, @AddrDest, @Size

    cld
    mov esi,[@AddrSrc]
    mov edi,[@AddrDest]
    mov ecx,[@Size]
    shr ecx,2
    rep movsd
    mov ecx,[@Size]
    and ecx,3
    rep movsb

    ret
endf

;===========================================================================================
; Limiter le nombre de frames par seconde
;-------------------------------------------------------------------------------------------
; @FpsMax = Nombre de frames par secondes maximum
;-------------------------------------------------------------------------------------------
; Utilisation:
; invoke timeBeginPeriod,1    ;au dbut du programme
; mov D[FpsMax],75
;
; invoke GetTickCount         ;dans MessageLoop
; mov [TickCount],eax
; invoke FpsLimiter,[FpsMax]
;
; invoke timeEndPeriod,1      ; la fin du programme
;===========================================================================================
FpsLimiter frame @FpsMaxi
    uses ebx,edx
    local .DelayTicks:D
    local .MinTicksForSleep:D

    cmp D[@FpsMaxi],0
    jne >
        ret
    :
    invoke QueryPerformanceFrequency,addr PerfFreq

    mov eax,D[PerfFreq]
    mov edx,D[PerfFreq+4]
    div D[@FpsMaxi]
    mov [.DelayTicks],eax

    mov eax,D[PerfFreq]
    mov edx,D[PerfFreq+4]
    mov ebx,500
    div ebx
    mov [.MinTicksForSleep],eax

    .loop1:
        .loop2:
            invoke QueryPerformanceCounter,addr PerfCounter
            mov eax,D[PerfCounter]
            mov edx,D[PerfCounter+4]

            cmp edx,[NextTimeEdx] 
            jne >.exit
            cmp eax,[NextTimeEax]
            jae >.exit
            
            mov ebx,[NextTimeEax]
            sub ebx,eax
        cmp ebx,[.MinTicksForSleep]
        jb .loop2
        push eax
        invoke Sleep,1
        pop eax
    jmp .loop1

 .exit:
    add eax,[.DelayTicks]
    mov [NextTimeEax],eax
    mov [NextTimeEdx],edx

    ret
endf

;===========================================================================================
; Dfinitions des datas chaines / variables initialises ou non initialises / structures
;-------------------------------------------------------------------------------------------
.data

  ptBitmap INCBIN res\bitmap.bmp, 14                    ;atteindre adresse BITMAPINFOHEADER
  Titre       db ' Animate ',0
  ClassName   db ' AsmGges Win32',0
  MsgEnd      db ' GoAsm AsmGges France @2006  ',0

  FontMS      db 'MS Sans Serif',0
  ButtonInc   db 'Speed +',0
  ButtonDec   db 'Speed -',0
  ButtonRun   db 'Animate Me',0
  ButtonStop  db 'Stop Me',0
  ButtonGBox  db 'AsmGges Program',0

  Button      db 'BUTTON',0
  align 4

  WinX        dd 0
  WinY        dd 100
  WinW        dd 200
  WinH        dd 224

  Fps         dd 0
  FpsMax      dd 0
  NextTimeEdx dd 0
  NextTimeEax dd 0
  PerfFreq    dq 0
  PerfCounter dq 0

  BtRun       dd 0
  Anim        dd 0

  hMemDC      dd ?
  hOld        dd ?
  hBitmap     dd ?
  hAnimDC     dd ?
  ppvBits     dd ?
  hWnd        dd ?
  hFontMS     dd ?

  wc          WNDCLASS    < 0,addr WindowProc, 0, 0, NULL, NULL, NULL,\
                            COLOR_BTNFACE+1, 0, addr ClassName >
  msg         MSG         <>
  ps          PAINTSTRUCT <>

;===========================================================================================

